' Nasty bug exists in QB64, after calling Magnetica, the sort is ok from C side, but not okay when the array of _OFFSET is used to read the sorted lines?!
' When calling Magnetica_DUMP the file 'Magnetica.txt' is created and it is identical to 'Schmekeriada.txt' created from 'textfile' with Schmekerezada_GCC_13.0.1_SSE4.2_TetraThread.exe

'Benchmark (sorting 3,000,000 strings, up to 62 chars) on Windows 10 and i5-7200U 3.1GHz Max Turbo:
' Quicksort recursive:               8.16s
' Quicksort iterative:               7.54s
' Quicksort 'Magnetica':             4.22s
' Quicksort multithreaded Magnetica: 1.82s

'https://qb64phoenix.com/forum/showthread.php?tid=1711&pid=16188#pid16188
' b+ source modified by Kaze
'Option _Explicit
_Define A-Z As _INTEGER64

Declare CustomType Library
    Sub memcpy (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
End Declare

Declare CustomType Library "./qsm" ' Notice that 'CustomType' makes things work, using 'STATIC' gives errors during compilation
    'Sub Quicksort_QB64_v14 (ByVal QWORDS As _Offset, Byval NumOfEle As _Integer64)
    Sub Quicksort_Magnetica_v18_Koffcheg (ByVal Left As _Offset, Byval Right As _Offset)
    '//void Quicksort_Magnetica_v18_Balxchonka_indirect (uint64_t* Left, uint64_t* Right, size_t Order) { // Order is 0 for [CR]LF postfixed chunks with variable length
    '//        printf( "Sorting pointers to lines with 'Quicksort_Magnetica_v18_Balxchonka_indirect' ...\n" );
    '//        Quicksort_Magnetica_v18_Balxchonka_indirect(&xgamsCACHE[0], &xgamsCACHE[NumberOfLFs-1], 0);
    Sub Magnetica_v18_Balxchonka_indirect (ByVal Left As _Offset, Byval Right As _Offset, Byval Ordr As _Integer64)
    Sub Magnetica_v18_Balxchonka_indirect_DUMP (ByVal Left As _Offset, Byval Right As _Offset, Byval Ordr As _Integer64)
End Declare

_Title "Magnetica versus Quicksort" ' b+ 2023-05-30
Randomize Timer ' so we have a different array each time we compare

Width , 43
'DefLng A-Z
Const nItems = 30 * 1000000
Const MaxLen = 63
'Dim sa$(1 To nItems) ' setup a string array sa$() to sort
'Dim copy$(1 To nItems) ' make a copy of sa$() to compare another sort to
'Dim copy1$(1 To nItems) ' make a copy of sa$() to compare another sort to
'Dim copy2$(1 To nItems) ' make a copy of sa$() to compare another sort to
Dim As Long i, j ' indexes to array  for building and displaying the arrays
Dim As Long r '  a random posw integer = 2 to 6
Dim t##, qtime##, ctime##
Dim b$ ' building string

Open "textfile" For Output As #1
For i = 1 To nItems ' make a random list to sort
    b$ = ""
    r = (Rnd * MaxLen) ' could be ""
    If r Then
        For j = 1 To r
            b$ = b$ + Mid$("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.?", (Rnd * 64) \ 1 + 1, 1)
        Next
        'sa$(i) = b$
        'copy1$(i) = b$
        'copy2$(i) = b$
    End If
    Print i, b$
    Print #1, b$
Next
Close #1
Print
Print "Press any key to commence Quicksort showdown ..."
Sleep

ReDim sa$(1 To nItems) ' setup a string array sa$() to sort
GoSub UploadArray
Print "Sorting..."
t## = Timer(.001)
QuickSort 1, nItems, sa$()
qtime## = .001 + Timer(.001) - t##
For i = 1 To 3
    Print i, sa$(i)
Next
Print "..."
For i = nItems - 2 To nItems
    Print i, sa$(i)
Next
Print: Print
Print "  Quick Sort time:"; qtime##
Print "  Quick Sort performance:"; nItems / qtime##; "Items-Per-Second"

ReDim sa$(1 To nItems) ' setup a string array sa$() to sort
GoSub UploadArray
Print "Sorting..."
t## = Timer(.001)
Quicksort_QB64_Kaze_str sa$()
qtime## = .001 + Timer(.001) - t##
For i = 1 To 3
    Print i, sa$(i)
Next
Print "..."
For i = nItems - 2 To nItems
    Print i, sa$(i)
Next
Print: Print
Print "  Quick_Sort_Iterative time:"; qtime##
Print "  Quick_Sort_Iterative performance:"; nItems / qtime##; "Items-Per-Second"

ReDim sa$(1 To nItems) ' setup a string array sa$() to sort, also  release the old string pool
' Return to the realworld scenario of sorting [CR]LF postfixed lines [
'Open "textfile" For Output As #1
'For i = 1 To nItems
'    Print #1, copy2$(i) 'instead of data+000=ASCIIZ we have data+CRLF
'Next
'Close #1
Open "textfile" For Binary As #1
GetItInVar = LOF(1)
TheWholeFile$ = Space$(GetItInVar)
Get #1, , TheWholeFile$
Close #1
' Return to the realworld scenario of sorting [CR]LF postfixed lines ]

'char *AvoidSEEKS;
'elements = size_in64;
'AvoidSEEKS = (char *)malloc( elements +2); // +2 in order to insert LF or CRLF i.e. ASCII 10 or 1310 at the end if the last byte is not LF
'xgamsCACHE = (uint64_t *)malloc( (NumberOfLFs+PlusOneOrTwo)*8 );
'printf( "Assigning pairs (of pointers and lengths) to lines ... " ); // When dumping, should add LF after every *(xgamsCACHElen+j) bytes
'        clocks1 = clock();
'    j=0;
'    i=0;
'        *(xgamsCACHE+j) = (uint64_t)(AvoidSEEKS+i);
'        for(i=0;i<size_in64+PlusOneOrTwo;i++) {
'                CurrentLine++;
'        if (AvoidSEEKS[i]==10) {
'                        CurrentLine--;
'                        *(xgamsCACHElen+j) = CurrentLine;
'                        if (LongestLine<CurrentLine) LongestLine=CurrentLine;
'                        CurrentLine=0;
'            if (j+1<NumberOfLFs) {
'                j++;
'                    *(xgamsCACHE+j) = (uint64_t)(AvoidSEEKS+i+1);
'            }
'        }
'        }

ReDim Pointers64bitToStrings(1 To nItems + 1) As _Offset
Pointers64bitToStrings(1) = _Offset(TheWholeFile$)
AlreadyIndexed = 1
FoundAt = 0
Do While AlreadyIndexed < nItems + 1
    FoundAt = InStr(FoundAt + 1, TheWholeFile$, Chr$(10)) ' we need the position next to LF - it is the QB's instr() since it works starting at 1, in C we start at 0
    AlreadyIndexed = AlreadyIndexed + 1
    Pointers64bitToStrings(AlreadyIndexed) = Pointers64bitToStrings(1) + FoundAt
Loop

'' Dump [
'Open "textfile.bak" For Output As #1
'a$ = Space$(MaxLen)
'For i = 1 To nItems
'    j = 0
'    Do
'        memcpy _Offset(a$) + j, Pointers64bitToStrings(i) + j, 1
'        j = j + 1
'    Loop While Pointers64bitToStrings(i) + j < Pointers64bitToStrings(i + 1)
'    Print #1, Left$(a$, j - 2) '-2 in order to strip CRLF - print adds CRLF
'Next
'Close #1
'' Dump ]

Print "Sorting..."
t## = Timer(.001)
'Magnetica_v18_Balxchonka_indirect _Offset(Pointers64bitToStrings(1)), _Offset(Pointers64bitToStrings(nItems)), 0
Magnetica_v18_Balxchonka_indirect_DUMP _Offset(Pointers64bitToStrings(1)), _Offset(Pointers64bitToStrings(nItems)), 0 ' dumps the sorted file into 'Magnetica.txt'
qtime## = .001 + Timer(.001) - t##
Print: Print
Print "  Quick_Sort_Magnetica time:"; qtime##
Print "  Quick_Sort_Magnetica performance:"; nItems / qtime##; "Items-Per-Second"

t## = Timer(.001)
$If WIN Then
    Print "Sorting with EXE..."
    Shell "Schmekerezada_GCC_13.0.1_SSE4.2_TetraThread.exe textfile"
$Else
    Print "Sorting with ELF..."
    Shell "./Schmekerezada_GCC_13.0.1_SSE4.2_TetraThread.elf textfile"
$End If
qtime## = .001 + Timer(.001) - t##
Print: Print
Print "  Quick_Sort_Magnetica time:"; qtime##
Print "  Quick_Sort_Magnetica performance:"; nItems / qtime##; "Items-Per-Second"

'C:\qb64202\QB64qsort>fc Magnetica.txt Schmekeriada.txt /b
'Comparing files Magnetica.txt and SCHMEKERIADA.TXT
'FC: no differences encountered

'C:\qb64202\QB64qsort>

End

UploadArray:
Print "Loading..."
Open "textfile" For Binary As #1 ' using BINARY mode instead of INPUT since the former is faster!
For i = 1 To nItems ' make a random list to sort
    Line Input #1, sa$(i)
Next
Close #1
Return





















Print
Print "  Press any to Comb Sort with array copy, zzz..."
Print
Print
Sleep
t## = Timer(.001)
CombSort copy$()
ctime## = Timer(.001) - t##
For i = 1 To 10
    Print copy$(i),
Next
Print: Print
For i = nItems - 9 To nItems
    Print copy$(i),
Next
Print: Print
Print "  Comb Sort time:"; ctime##
Print
If ctime## < qtime## Then Print "  Comb winds!" Else Print "  QSort wins again!"


Sub QuickSort (start As Long, finish As Long, arr$())
    Dim Hi As Long, Lo As Long, Middle$
    Hi = finish: Lo = start
    Middle$ = arr$((Lo + Hi) / 2) 'find middle of arr$
    Do
        Do While arr$(Lo) < Middle$: Lo = Lo + 1: Loop
        Do While arr$(Hi) > Middle$: Hi = Hi - 1: Loop
        If Lo <= Hi Then
            Swap arr$(Lo), arr$(Hi)
            Lo = Lo + 1: Hi = Hi - 1
        End If
    Loop Until Lo > Hi
    If Hi > start Then Call QuickSort(start, Hi, arr$())
    If Lo < finish Then Call QuickSort(Lo, finish, arr$())
End Sub

' trans from johnno ref: https://rcbasic.freeforums.net/thread/779/sort-algorithms
Sub CombSort (arr$())
    Dim As Long itemCount, start, fini, swaps, gap, i
    start = LBound(arr$)
    itemCount = UBound(arr$) - start + 1
    fini = start + itemCount - 1
    gap = itemCount
    While gap > 1 Or swaps <> 0
        gap = Int(gap / 1.25)
        If gap < 1 Then gap = 1
        swaps = 0
        For i = start To itemCount - gap
            If arr$(i) > arr$(i + gap) Then
                Swap arr$(i), arr$(i + gap)
                swaps = 1
            End If
        Next
    Wend
End Sub



' Written by Sanmayce, 2021-Oct-29
_Define A-Z As _INTEGER64
Sub Quicksort_QB64_Kaze_str (QWORDS$())
    Left = LBound(QWORDS$)
    Right = UBound(QWORDS$)
    LeftMargin = Left
    ReDim Stack&&(Left To Right)
    StackPtr = 0
    StackPtr = StackPtr + 1
    Stack&&(StackPtr + LeftMargin) = Left
    StackPtr = StackPtr + 1
    Stack&&(StackPtr + LeftMargin) = Right
    Do 'Until StackPtr = 0
        Right = Stack&&(StackPtr + LeftMargin)
        StackPtr = StackPtr - 1
        Left = Stack&&(StackPtr + LeftMargin)
        StackPtr = StackPtr - 1
        Do 'Until Left >= Right
            Pivot$ = QWORDS$((Left + Right) \ 2)
            Indx = Left
            Jndx = Right
            Do
                Do While (QWORDS$(Indx) < Pivot$)
                    Indx = Indx + 1
                Loop
                Do While (QWORDS$(Jndx) > Pivot$)
                    Jndx = Jndx - 1
                Loop
                If Indx <= Jndx Then
                    If Indx < Jndx Then Swap QWORDS$(Indx), QWORDS$(Jndx)
                    Indx = Indx + 1
                    Jndx = Jndx - 1
                End If
            Loop While Indx <= Jndx
            If Indx < Right Then
                StackPtr = StackPtr + 1
                Stack&&(StackPtr + LeftMargin) = Indx
                StackPtr = StackPtr + 1
                Stack&&(StackPtr + LeftMargin) = Right
            End If
            Right = Jndx
        Loop Until Left >= Right
    Loop Until StackPtr = 0
End Sub


